
TYPO3.Fluid - Feature # 35790

Work Package # 45013 (Resolved): Flexible plugin integration (TODO: Reviews)

Status: Resolved Priority: Should have
Author: Fernando Arconada Category: ViewHelpers
Created: 2012-04-09 Assigned To: Karsten Dambekalns
Updated: 2013-05-06 Due date:
Has patch: No
Subject:  allow f:link.action to operate on parent request
Description

Original bug description:

if you use f:link.action inside a widget it generates links to the widget actions and not links to other controllers as expected

See below for feature description

Related issues:
related to TYPO3.Fluid - Bug # 46135: Undefined index: useParentRequest in Ab... Closed 2013-03-08

Associated revisions
Revision 6b5f0d05 - 2013-02-20 12:28 - Marc Neuhaus 

[FEATURE] Allow f:link.action to operate on parent request

Add an useParentRequest argument to link.action, uri.action,
and form ViewHelpers to generate links using the Parent
Request instead of the current Request.

Resolves: #35790
Releases: master
Change-Id: If75cb451a7954c491cfdc539ea28653c99f82e79

Revision e3736a88 - 2013-05-06 09:15 - Marc Neuhaus 

[FEATURE] Allow f:link.action to operate on parent request

Add an useParentRequest argument to link.action, uri.action,
and form ViewHelpers to generate links using the Parent
Request instead of the current Request.

Resolves: #35790
Releases: master, 2.0
Change-Id: If75cb451a7954c491cfdc539ea28653c99f82e79

History
#1 - 2012-04-24 12:08 - CPS-IT GmbH

2015-08-03 1/6



I don't think this is a bug. The viewhelper takes the current controller context which is the widget one's. If you need to link to any other controller (e.g.
origin request) you have to assign variables for this and submit them in your template.

$this->view->assign('parentPackage', $this->request->getParentRequest()->getControllerPackageKey());
$this->view->assign('parentSubpackage', $this->request->getParentRequest()->getControllerSubpackageKey());
$this->view->assign('parentController', $this->request->getParentRequest()->getControllerName());
$this->view->assign('parentActionName', $this->request->getParentRequest()->getControllerActionName());

In your Fluid template you can do something like this

<f:link.action action="{parentActionName}" controller="{parentController}" package="{parentPackage}"
subpackage="{parentSubpackage}">Link</f:link.action>

#2 - 2012-06-25 23:07 - Krzysztof Daniel

We have this defined as:
<f:link.action package="xxx.Package" controller="Setup" action="close">close</f:link.action>
And still the link is routed internally in the widget.

#3 - 2012-08-23 10:05 - Christoph Gross

Same problem, even with package, subpackage and controller defined the link.action fails to generate the correct link within widgets. 

<f:link.action 
    arguments="{account: account}" 
    package="Drinkaccounting" 
    action="show" 
    controller="Account">{account.name}</f:link.action>

http://f3.local/drinkaccounting/controllcenter/index
?--drinkaccounting-viewhelpers-widget-mainnavigationviewhelper[account][__identity]=ec663b7d-04e6-4d9c-8875-eac772f51312
&--drinkaccounting-viewhelpers-widget-mainnavigationviewhelper[@action]=show
&--drinkaccounting-viewhelpers-widget-mainnavigationviewhelper[@controller]=account
&--drinkaccounting-viewhelpers-widget-mainnavigationviewhelper[@package]=drinkaccounting

Also link.action shouldn't generate link to widget actions since there is a viewhelper for that:
<f:uri.widget>
    Generates an URI to another action of the widget.
<f:link.widget>
    Generates a link to another action of the widget.

#4 - 2012-08-23 18:07 - Christoph Gross
- File widgetLinkWorkaround.patch added
I attached a dirty workaround. The problem seems to be with the argumentNamespace and subPackage. Couldn't figure out how to fix.
The workaround might only work for projects without subpackages, but I'm not sure about that.

EDIT: Forgot to say: The Patch is for Flow/Mvc/UriBuilder.php

#5 - 2012-09-14 14:32 - Dominique Feyer

Any news on this issue ?

#6 - 2012-11-10 15:13 - Christoph Gross

Patch does not work anymore in latest Typo3 Flow (1.2 dev-master). This really should be fixed. I currently use the widgets to display a menu with
direct access to some objects. That's not an exotic use-case.

Unfortunately I had no success in finding the bug.

#7 - 2012-11-10 17:34 - Christoph Gross

After some digging I found another (dirty) workaround for Flow 1.2:

It seems that the problem occurs when the namespaces are added. This somehow has to do with the nesting of the requests and that's why we get
wrong links.

If you change in Typo3/Flow/Mvc/UriBuilder.php the function addNamespaceToArguments to this:

protected function addNamespaceToArguments(array $arguments, \TYPO3\Flow\Mvc\RequestInterface $currentRequest) {
        while (!$currentRequest->isMainRequest()) {
            $argumentNamespace = $currentRequest->getArgumentNamespace();
            if ($argumentNamespace !== '') {

                if(strstr($argumentNamespace, 'viewhelpers-widget')) {
                    $arguments["@subpackage"] = NULL;
                    $arguments = $arguments;
                } else {
                    $arguments = array($argumentNamespace => $arguments);
                }
            }
            $currentRequest = $currentRequest->getParentRequest();
        }

        return $arguments;
    }

It works again. This will have some sideeffects if you use links within your widget I think.

#8 - 2013-01-30 23:38 - Christoph Gross
But still present in latest Flow version (2.0)

#9 - 2013-02-01 13:44 - Marc Neuhaus

This Behavior is actually no bug, it's by Design.

Widgets are executed in an SubRequest and because of this the URI Builder generates the Link inside that Request.
Currently there is no default way to generate links for another Request.

I'll raise this issue with Sebastian.

#10 - 2013-02-01 14:38 - Christoph Gross

Ah, that explains the behavior, would be nice to somehow circumvent it since we have a fluid tag for widget links and one for actions:

<f:uri.widget> / <f:link.widget>
    Generates an URI / link to another action of the widget.
<f:link.action> / <f:uri.action>
    Generates a link / URI to another action.

#11 - 2013-02-05 14:59 - Bastian Waidelich
- Tracker changed from Bug to Feature
- Subject changed from  f:link.action inside a widget fails to  allow f:link.action to operate on parent request
- Category set to ViewHelpers
- Status changed from New to Accepted
- Priority changed from Must have to Should have

Add argument useParentRequest (boolean) to relevant link & uri ViewHelpers

#12 - 2013-02-05 14:59 - Bastian Waidelich
- Assigned To set to Marc Neuhaus

#13 - 2013-02-06 10:22 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18045

#14 - 2013-02-06 11:39 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18045

2015-08-03 4/6

https://review.typo3.org/18045
https://review.typo3.org/18045


#15 - 2013-02-06 14:07 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18045

#16 - 2013-02-06 14:31 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18045

#17 - 2013-02-06 16:21 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18045

#18 - 2013-02-11 15:15 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18045

#19 - 2013-02-11 16:24 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18045

#20 - 2013-02-20 12:29 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18045

#21 - 2013-03-05 15:36 - Anonymous
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:6b5f0d051dc1863a271c45a1ebcd616f81c3bf0b.

#22 - 2013-03-18 15:09 - Marc Neuhaus
- Parent task set to #45013

#23 - 2013-05-06 09:15 - Christopher Hlubek
- Status changed from Resolved to Needs Feedback
- Assigned To changed from Marc Neuhaus to Karsten Dambekalns

Since this is a blocker to use widgets in other ways than just a pagebrowser with widget-only links, I think we need that also in 2.0. Also since this is
not the Flow package and not a big feature it shouldn't be a problem.

#24 - 2013-05-06 09:16 - Gerrit Code Review
- Status changed from Needs Feedback to Under Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/20544

#25 - 2013-05-06 16:03 - Bastian Waidelich
- Target version set to 2.0

#26 - 2013-05-06 19:35 - Anonymous
- Status changed from Under Review to Resolved

Applied in changeset commit:e3736a887a7278742961ef925a3bd8513e38447f.

Files
widgetLinkWorkaround.patch 437 Bytes 2012-08-23 Christoph Gross
